;Ctrl+P to pause script and Ctrl+P again to resume
;The AHK icon in system tray will turn red while paused.
;Ctrl+R to reload script
;Release Date: 10/24/2010
;Author: Cegaiel
;Credits to Takhetu for the loop/code that generates the combinations, of which mines to click.
;Thanks Fez for adding the 4th stone for silver :)


;Note you can hold the F2 key to break out of the loop when its selecting nodes.


;Last Update: 1/3/2012




;	// START CONFIGURATION AREA

	;Set the speed in microseconds (100 = 1/10th second, 1000 = 1 second, etc)
	;If you got a slower computer or lag, then try raising it 50 or 100 at a time, ie 200, 250, 300




	;This is the speed that it selects/highlights your ore nodes
	;Safe (lag) is 200-300, Fast is 100 (fast computer, no lag)

		Delay = 100  



	;This is the time it waits after finding/clicking a popup box, before it continues

	;180-200 for fairly lag free/fast computer. Try 300 or more for lagging/slow computers
	
		PopUpDelay = 200  



;	// END CONFIGURATION AREA








	ChatWarning = 0





			IfWinExist eGenesis Client
			{

			WinActivate, eGenesis Client
			WinWait, eGenesis Client
			WinGetActiveStats, win_Title, Xmax, Ymax, win_Xpos, win_Ypos 

			;Get coordinates, for your resolutions'  X,Y location of the popups (OK button) that will occur later.
			CenterX := Floor(Xmax/2)
			CenterY := Floor(Ymax/2)+103


			;Offset and create perimeter, around the ok button, when it searches around OK button area
			ClickPopX1 := CenterX - 40
			ClickPopY1 := CenterY - 30

			ClickPopX2 := CenterX + 30
			ClickPopY2 := CenterY + 30


			} else {
			MsgBox, eGenesis client not running, aborting...
			Exit
			}




	Gui, +AlwaysOnTop +ToolWindow
	Gui, Font, bold
	Gui, Add, Text,,Are you mining silver?
	Gui, Font, norm
	Gui, Add, DropDownList, vSilver Choose1,No|Yes 

	Gui, Add, Button, default gSetSilver, NEXT
	Gui, Show, x0 y25
	return


	SetSilver:
	Gui, Submit
	Gui, Destroy



	Start:
	MineNum = 0


	Gui, +AlwaysOnTop +ToolWindow
	Gui, Font, bold
	Gui, Add, Text, vMineNumText, Record ore stone positions
	Gui, Font, norm
	Gui, Add, Text,,
	( LTrim
	Hover and middle-click (Click mouse-wheel) on each ore stone, one by one,
	until you've clicked on all the stones. 

	AFTER setting (middle clicking) all your stones, then click the START button.

	(Drag this box out of the way if any stones are hidden)

	Reminder: Ctrl+P to Pause  -  Ctrl+R to Reload
	HOLD F2 key to abort when its clicking stones.

	)

	Gui, Add, Button, default gMineSetLoops, START
	Gui, Show, x0 y25


	WinGet, GameWinHandle, ID, eGenesis Client
	loop
	{

		;WinActivate
		CoordMode, Mouse, Relative
		KeyWait, MButton, D
		KeyWait, MButton
		MouseGetPos, TestX, TestY, WinHandle
		if (WinHandle = GameWinHandle)
		{
			Gosub, MineRecord
		}
		else
		{
			Gui, Destroy
			break
		}
	}
	return

	MineRecord:
	MineNum++
	MouseGetPos, MineX%MineNum%, MineY%MineNum%
	GuiControl, Text, MineNumText, %MineNum% ore stones captured
	return


	MineSetLoops:
	Gui, Submit
	Gui, Destroy



	SetDefaultMouseSpeed, 0


	if ChatWarning = 0
	Msgbox, Make sure your chat is MINIMIZED!`n`nThis message will not display again :)




Sleep 1000


if (Silver == "Yes")
{
Gosub, Silver
} else {
Gosub, Regular
}



Silver:

MainLoop := MineNum-3

Loop %MainLoop%
{

	FirstStone := A_Index
	NumToRun1 := MineNum-A_Index-2

	Loop, %NumToRun1%
	{
		SecondStone := FirstStone+A_Index
		NumToRun2 := MineNum-SecondStone

		Loop, %NumToRun2%
		{
			ThirdStone := SecondStone+A_Index
			NumToRun3 := MineNum-ThirdStone

			Loop, %NumToRun3%
			{
				FourthStone := ThirdStone+A_Index



Gosub, Popup
Gosub, SelectStones
Gosub, Popup

			}
		}
	}
}

Gosub, ChatWarning
return


Regular:

MainLoop := MineNum-2



Loop %MainLoop%
{

	FirstStone := A_Index
	NumToRun1 := MineNum-A_Index-1

	Loop, %NumToRun1%
	{
		SecondStone := FirstStone+A_Index
		NumToRun2 := MineNum-SecondStone

		Loop, %NumToRun2%
		{
			ThirdStone := SecondStone+A_Index


Gosub, Popup
Gosub, SelectStones
Gosub, Popup


		}
	}
}

Gosub, ChatWarning
return






ChatWarning:


	if ChatWarning = 0
	{
	Msgbox, Done, Click the mine and get a new workload!`n`nThis message will not display again :)
	ChatWarning = 1
	}

	Gosub, Start
	return





SelectStones:

;Debugging purposes only - Write all the combinations to a file
;FileAppend, %FirstStone%  %SecondStone%  %ThirdStone%  %FourthStone%`n, C:\temp\subwebs\atitd\macros\Mining_results.txt 


MouseMove, MineX%FirstStone%, MineY%FirstStone%
;Msgbox, FirstStone: MineX%FirstStone%, MineY%FirstStone%
Sleep %Delay%
Send {A}
Sleep %Delay%
Gosub Popup

MouseMove, MineX%SecondStone%, MineY%SecondStone%
;Msgbox, SecondStone: MineX%SecondStone%, MineY%SecondStone%
Sleep %Delay%
Send {A}
Sleep %Delay%
Gosub Popup

MouseMove, MineX%Thirdstone%, MineY%Thirdstone%
;Msgbox, ThirdStone: MineX%Thirdstone%, MineY%Thirdstone%
Sleep %Delay%
Send {A}
Sleep %Delay%
Gosub Popup


if (Silver == "Yes")
{
MouseMove, MineX%FourthStone%, MineY%FourthStone%
;Msgbox, FourthStone: MineX%FourthStone%, MineY%FourthStone%
Sleep %Delay%
Send {A}
Sleep %Delay%
Gosub Popup
}



;Finalize
Send {S}
Sleep %Delay%
Gosub Popup

return






			Popup:

			ImageSearch, PopX, PopY, ClickPopX1, ClickPopY1, ClickPopX2, ClickPopY2, *50 OK.PNG
			if ErrorLevel = 0
			{
			NewX := PopX + 3
			NewY := PopY + 3
			;BlockInput, MouseMove
			Click %NewX%, %NewY%
			Sleep %PopUpDelay%
			;BlockInput, MouseMoveOff			



			;If popup is detected, then go back and keep checking until it is closed for sure, in case lag interfered with it closing properly

			Gosub, Popup    
			}
				;See if user is holding the F2 key down to abort script, while its clicking nodes.
				GetKeyState, state, F2
				if state = D
				Gosub, Start

			return






^r::reload
^p::Pause
